'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const { limit, skip, sort, filters } = body;
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            query GetCompanies($input: ListArguments!) {
                getCompanies(input:$input) {
                    data {
                        _id
                        uuid
                        company_type
                        commercial_type
                        tax_no
                        default_lang_type
                        default_money_type
                        is_commercial
                        is_blacklist
                        workplace_no
                        official_address
                        top_responsible_company
                        parent_id
                        company_tag
                        formal_name
                        public_name
                        parent_id
                        expiryStarts
                        expiryEnds
                    }
                    totalCount
                }
            }
        `;
        const variables = { input: { limit, skip, sort, filters } };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.getCompanies.data, totalCount: data.getCompanies.totalCount });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
